' Siebel Component Groups Monitoring Script
' Created by:	Jacques Schoonooghe
' Date:				6 Jul 2009
' Version:		2.0
'
' This script monitors the timeout of running tasks
'
' Usage: start the script with 4 arguments: 
'		1. The Siebel Gateway
'		2. The Enterprise to monitor
'		3. The Siebel user
'		4. The Siebel Users password
' 	e.g.: cscript /NoLogo siebtaskrun.vbs localhost ENTERPRISE1 user password
'
' Adapt following variables in the script:
'		vLOGFILESIZELIMIT The logfile size is set by default to 10MB (10000000 bytes)
'		vTIMEOUT (default in the script is set to 30 seconds) This variable limits the time to wait for an answer from srvrmgr.exe
'		vTASKTIMEOUT (default set to 2 Hours) This is the threshold for the timeout of the tasks to monitor


Option Explicit
Dim WshShell, Objfso, Objnetw, oSIEBSTAT, oTEXT, oLOGFILE, oExec, oSIEBSTATLST, oMONITORLST, oINPUTFILE 'Define required objects
Dim objSWbemServices, colProcess, objProcess
Dim l, k, i							' Counters
Dim vBINPATH					' Full path to SIEB_HOME\bin\
Dim vOUTPUTFILE				' The filename where to write the status to for troubleshooting
Dim vINPUTFILE				' the srvrmgr input file
Dim vSIEB_GTW					' The host where srvrmgr connects to
Dim vSIEB_ENT					' The enterprise to monitor
Dim vSIEBCMD					' srvrmgr.exe command to monitor the componet groups = compgrps
Dim vCMD2RUN					' The full command to run
Dim vLINE							' A dummy variable for line reading
Dim vSV_NAME
Dim vLOGFILE					' The logfile for this script
Dim vERROR 						' Standard error variable
Dim vUSER							' The Siebel user
Dim vPASSWORD					' The Siebel users password
Dim vERR_NR						' Number of Componentgroups or servers in errorstate
Dim vSEV							' Severity
Dim vINDENT						' Add ====> for alerts in monitor.log file
Dim vLOGFILESIZELIMIT	' The maximum filesize in bytes of the different logfiles before creating the .1 backup logfiles
Dim vLOGFILESIZE			' The filesize of the logfile
Dim vTIMEOUT					' Timeout variable in seconds
Dim vMONDIR						' Monitoring directory
Dim vSIEBLST					' List file containing enterprisename and siebelserver bin path
Dim vPIDSRVRMGROLD		' Process ID of the running srvrmgr.exe process started by another Siebel monitor.
Dim vPID							' Process ID of the monitor
Dim afield, aMONFIELD	'Temp arrays for fields
Dim strSHARE
Dim oNetDrives
Dim oEXCLFILE, oEXCLLIST, aEXCLLINE, vEXCLLINE
Dim vERR
Dim vEXCL
Dim vLOGDIR
Dim vTASKTIMEOUT
Dim vTASKTIMEOUTELEM
Dim vCC_ALIAS
Dim vTK_TASKID
Dim vTK_DISP_RUNSTATE
Dim vTK_START_TIME
Dim vTK_PID
Dim vSTATUS

Set WshShell = WScript.CreateObject("WScript.Shell") 
Set Objfso = CreateObject("Scripting.FilesystemObject")
Set Objnetw = CreateObject("Wscript.Network")
Set objSWbemServices = GetObject ("WinMgmts:Root\Cimv2") 
vERR_NR = 0

vMONDIR = left(WScript.ScriptFullName,(Len(WScript.ScriptFullName))-(len(WScript.ScriptName)))
vLOGDIR = vMONDIR & "\logs\"
If Not Objfso.folderexists(vLOGDIR) Then
	Objfso.createfolder vLOGDIR
	wscript.sleep 200
End If
vINDENT = "        "
vLOGFILESIZELIMIT = 10000000
vTIMEOUT = 30
vTASKTIMEOUT = 2
vTASKTIMEOUTELEM = "h" 'h: Hours, n: Minutes, s: Seconds.
vSIEBCMD = "tasks"
vLOGFILE = vLOGDIR & "SIEBTASKRUN.log"
vSIEBLST = vMONDIR & "SIEBMON.lst"
vINPUTFILE = vMONDIR & "SIEBTASKRUNINPUT.txt"

'	### Monitor logfile creation ###

If objFSO.FileExists(vLOGFILE) Then
	vLOGFILESIZE = CLng(objFSO.GetFile(vLOGFILE).size)
	If vLOGFILESIZE > vLOGFILESIZELIMIT Then
		objFSO.CopyFile vLOGFILE, vLOGFILE & "1",True
		objFSO.DeleteFile(vLOGFILE)
	End If
End If

Set oLOGFILE = objFSO.OpenTextFile(vLOGFILE, 8, True)

l = 0
Set colProcess = objSWbemServices.ExecQuery("Select * From Win32_Process") 
For Each objProcess In colProcess 

' ### Log PID to logfile ###

	If InStr (objProcess.CommandLine, WScript.ScriptName) <> 0 Then 
		vPID = objProcess.ProcessId
		oLOGFILE.WriteLine(Now & vbTAB & "-----------------------------------------------------")
		oLOGFILE.WriteLine(Now & vbTAB & " Monitoring started with PID: " & vPID)
	End If 

' ### Check for existing srvrmgr processes ###

	If InStr (objProcess.CommandLine, "srvrmgr") <> 0 Then 
		vPIDSRVRMGROLD = objProcess.ProcessId
		Do While l <= vTIMEOUT
			wscript.sleep 1000
			l = l + 1
			If l = vTIMEOUT Then
				oLOGFILE.WriteLine(Now & vbTAB & "-----------------------------------------------------")
				oLOGFILE.WriteLine(Now & vbTAB & "WARN => Monitoring timed out. Another srvrmgr.exe is running with PID: " & vPIDSRVRMGROLD)
				oLOGFILE.WriteLine(Now & vbTAB & "-----------------------------------------------------")
				oLOGFILE.close
				wscript.echo "Timeout reached. Waited " & vTIMEOUT & " seconds for another Siebel Monitor to end"
				wscript.quit(1)
			End If
		loop
	End If
Next


'	### Check arguments and read variables ###

If WScript.Arguments.Count < 4 Then
	vINDENT = "WARN => "
	WScript.Echo "Not all arguments are given. I need 4 arguments. No monitoring."
	oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Not all arguments are given. I need following 4 arguments: gateway enterprise user password")
	oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Monitor did not run")
	Wscript.Quit(1)
End If

vSIEB_GTW = Wscript.Arguments.Item(0)
vSIEB_ENT = Wscript.Arguments.Item(1)
vUSER = Wscript.Arguments.Item(2)
vPASSWORD = Wscript.Arguments.Item(3)

Set oSIEBSTATLST = Objfso.getfile(vSIEBLST)
Set oMONITORLST = oSIEBSTATLST.openastextstream

vLOGFILE= vLOGDIR & "SIEBTASKRUNMON_" & vSIEB_ENT &".log"

oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Start logging into " & vLOGFILE)
oLOGFILE.WriteLine(Now & vbTAB & "-----------------------------------------------------")
oLOGFILE.Close

' ### Change logfile

If objFSO.FileExists(vLOGFILE) Then
	vLOGFILESIZE = CLng(objFSO.GetFile(vLOGFILE).size)
	If vLOGFILESIZE > vLOGFILESIZELIMIT Then
		objFSO.CopyFile vLOGFILE, vLOGFILE & "1",True
		objFSO.DeleteFile(vLOGFILE)

	End If
End If
Set oLOGFILE = objFSO.OpenTextFile(vLOGFILE, 8, True)
oLOGFILE.WriteLine(Now & vbTAB & "-----------------------------------------------------")
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Monitoring for " & vSIEB_ENT & " started")

'	###	Check path parameters in vSIEBLST ###

l = 0
Do While Not oMONITORLST.atendofstream
	l = l + 1
	aMONFIELD = split(oMONITORLST.readline,"|")
	If aMONFIELD(0) = vSIEB_ENT Then
		k = l
		vBINPATH = aMONFIELD(1)
		vOUTPUTFILE = vLOGDIR & "SIEBTASKRUN_" & vSIEB_ENT & ".txt"
	End If
loop

If vBINPATH ="" Then
	vINDENT = "CRIT => "
	wscript.echo "Enterprise name (" & vSIEB_ENT & ") in arguments unknown in " & vSIEBLST & ".  No monitoring."
	oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Enterprise name (" & vSIEB_ENT & ") in arguments unknown in " & vSIEBLST)
	oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Monitor did not run")
	oLOGFILE.Close
	wscript.quit(1)
ElseIf Left(vBINPATH,2)="\\" Then
	strSHARE = "\\" & split(vBINPATH,"\")(2) & "\" & split(vBINPATH,"\")(3)
	Set oNetDrives = Objnetw.EnumNetworkDrives
	For l = 1 To oNetDrives.Count-1 Step 2
		If oNetDrives.item(l) = strSHARE Then
			Objnetw.RemoveNetworkDrive oNetDrives.item(l)
		End If
	Next
	
	Objnetw.MapNetworkDrive "", strSHARE, False

End If

' ### Start monitoring ###

oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Monitor: " & k)
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Gateway: " & vSIEB_GTW)
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Enterprise: " & vSIEB_ENT)
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "User account: " & vUSER)
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Monitor type: " & vSIEBCMD)
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Monitor based on line " & k &" in " & vSIEBLST)
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "########################################")

' ### srvrmgr input file creation ###

Set oINPUTFILE = objFSO.OpenTextFile(vINPUTFILE, 8 ,True)
oINPUTFILE.WriteLine("set delimiter |")
oINPUTFILE.Writeline("list " & vSIEBCMD)
oINPUTFILE.Close	
Wscript.sleep 1000

' ### Run srvrmgr with parameters

vCMD2RUN = vBINPATH & "srvrmgr /g " & vSIEB_GTW & " /e " & vSIEB_ENT & " /u " & vUSER & " /p " & vPASSWORD & " /i " &  vINPUTFILE & " /o " & vOUTPUTFILE	'Define the command to run

Set oExec = WshShell.Exec(vCMD2RUN)
l = 0
Do While oExec.Status = 0
	WScript.Sleep 1000
  l = l + 1
  If l = vTIMEOUT Then
   	vINDENT = "CRIT => "
    Wscript.echo "Monitor time out. It took " & vTIMEOUT & " secs to run."
    oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Monitoring Timed out. It took more than " & vTIMEOUT & " secs to run.")
		oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Monitor did not run")
		objFSO.DeleteFile(vINPUTFILE)
		If Not strSHARE ="" Then
			Objnetw.RemoveNetworkDrive strSHARE
		End If
		wscript.quit(1)
  End If
Loop

objFSO.DeleteFile(vINPUTFILE)

If Not strSHARE ="" Then
	Objnetw.RemoveNetworkDrive strSHARE
End If

'	###	On connectionerror: gateway down  ###

If Left(vERROR,22) = "Fatal error (3900018):" Then
	vINDENT = "CRIT => "
	wscript.echo "Gateway down for enterprise " & vSIEB_ENT
	oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Gateway down for enterprise " & vSIEB_ENT)
	oLOGFILE.WriteLine(Now & vbTAB & "Monitoring end")
	oLOGFILE.Close
	wscript.quit(2)
End If

'	### Read the outputfile from srvrmgr ###

Set oSIEBSTAT = Objfso.getfile(vOUTPUTFILE)
Set oTEXT = oSIEBSTAT.openastextstream

l = 0

vERR = 0

Do While Not oTEXT.atendofstream
	vLINE=oTEXT.readline
	l = l + 1

' ### Skip headerlines until line 22. If the enterprise cannot be connected it is mentioned at line 22 with error SBL-ADM-02071 ###

	If l = 22 Then
		Select Case Left(vLINE,14)
			Case "SBL-ADM-02071:"
				vINDENT = "CRIT => "
				wscript.echo "The enterprise cannot be contacted (SBL-ADM-02071)"
				oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "Enterprise " & vSIEB_ENT &" cannot be contacted: SBL-ADM-02071")
				oLOGFILE.WriteLine(Now & vbTAB & "Monitoring end")
				oLOGFILE.Close
				wscript.quit(2)
			Case "Connected to 0"
				vINDENT = "CRIT => "
				wscript.echo "No Servers can be contacted in the enterprise " & vSIEB_ENT
				oLOGFILE.WriteLine(Now & vbTAB & vINDENT & "No Servers can be contacted in the enterprise " & vSIEB_ENT)
				oLOGFILE.WriteLine(Now & vbTAB & "Monitoring end")
				oLOGFILE.Close
				wscript.quit(2)
			End Select
	End If

' ### Skip more headers ###

	If l > 29 Then
		If Not k="end" Then
			If vLINE="" Then
				k="end"
			Else

' ### Check component groups status ###
				afield = split(vLINE,"|")
				vSV_NAME = RTrim(afield(0))
				vCC_ALIAS = RTrim(afield(1))
				vTK_TASKID = RTrim(afield(2))
				vTK_PID = RTrim(afield(3))
				vTK_DISP_RUNSTATE = RTrim(afield(4))
				vTK_START_TIME = RTrim(afield(6))

				If vCC_ALIAS = "WfProcBatchMgr" Or vCC_ALIAS = "WfProcMgr" Then 'The script only monitors the Workflow Process Manager and Workflow Process Batch Manager. In a following version a list of components will be available in a listfile.
					If vTK_DISP_RUNSTATE = "Running" Then
						If DateDiff(vTASKTIMEOUTELEM,CDate(vTK_START_TIME),Now()) > vTASKTIMEOUT Then
							vINDENT = "CRIT => "
							vERR_NR = vERR_NR + 1
						End If
						oLOGFILE.WriteLine(Now & vbTAB & vINDENT & vCC_ALIAS & " with PID: " & vTK_PID & ", taskid: " & vTK_TASKID & " on " & vSV_NAME & " runs since " & CDate(vTK_START_TIME))
					End If
				End If

				

' ### Reset status for next check ###

				vINDENT = "        "
			End If
		End If
	End If
loop

' ### Print the outcome on StdOut

If vERR_NR > 0 Then
	vSTATUS = vERR_NR & " tasks are taking more than " & vTASKTIMEOUT & vTASKTIMEOUTELEM & " in enterprise " & vSIEB_ENT
	vSEV=2
Else
	vSTATUS = "All running tasks are within the limited timeout in enterprise " & vSIEB_ENT
	vSEV=0
End If

' ### Write end time in the monitor log ###

oLOGFILE.WriteLine(Now & vbTAB & vbTAB & vSTATUS)
wscript.echo vSTATUS
oLOGFILE.WriteLine(Now & vbTAB & vbTAB & "Monitoring end")
oLOGFILE.WriteLine(Now & vbTAB & "-----------------------------------------------------")
oLOGFILE.Close
wscript.sleep 5000
wscript.Quit(vSEV)